#!/usr/bin/perl -w

push @SPECHOOKS, sub {
    my ($spec, $parent, $pkgname) = @_;
    my @todel;
    my %scriptsec=map {$_=>1} qw/pre post preun postun
        triggerin triggerun triggerpostin triggerpostun/;
    foreach my $section ($spec->get_sections()) {
	my $secname=$section->get_type();
	next unless $scriptsec{$secname};
	$section->exclude_body(qr'^\s*touch\s+--no-create\s+(\%\{?_datadir\}?/icons|\%\{?_iconsdir\}?)/hicolor');
	$section->multi_exclude_body(
	    qr'^\s*if\s+\[\s+-x\s+.*gtk-update-icon-cache\s+\]\s*;\s*then',
	    qr'^\s*.*gtk-update-icon-cache',
	    qr'^\s*fi',
	    );
	$section->multi_exclude_body(
	    qr'^\s*\[\s+"?\$1"?\s+-eq\s+1\s+\] &&\s+\\$',
	    qr'^\s*.*gtk-update-icon-cache',
	    );
	my @body=@{$section->get_bodyref()};
	my @new_body;
	my $multiline=0;
	while (scalar @body) {
	    $_=shift(@body);
	    next if $multiline and /\\\s*$/;
	    if ($multiline and not /\\\s*$/) {
		$multiline=0;
		next;
	    }
	    if (/gtk-update-icon-cache/) {
		$multiline=1 if /\\\s*$/;
		next;
	    }
	    push @new_body, $_;
	}
	$section->set_body(\@new_body);
	$section->exclude_body(qr'gtk-update-icon-cache');
	
	my $flag_p=$section->get_flag('-p');
	if ((!$flag_p && $section->is_empty()) or ($flag_p && $flag_p=~/gtk-update-icon-cache/)) {
	    push @todel, [$secname,$section->get_raw_package(), $section->get_trigger_condition()];
	}
    }
    map {$spec->del_section($_->[0],$_->[1],$_->[2])} @todel;
};

1;

__END__
