#!/usr/bin/perl -w

push @SPECHOOKS, sub {
    my ($spec, $parent, $pkgname) = @_;
    my @todel;
    my %scriptsec=map {$_=>1} qw/pre post preun postun
        triggerin triggerun triggerpostin triggerpostun/;
    foreach my $section ($spec->get_sections()) {
	my $secname=$section->get_type();
	if ($secname eq 'package') {
	    $section->exclude_body(qr'^(?:Pre)?Req(?:uires)?\((post|preun|post,preun)\):\s*/sbin/install-info');
	    $section->exclude_body(qr'^Requires\(post\):\s*\%install_info\s*$');
	    $section->exclude_body(qr'^Requires\(preun\):\s*\%uninstall_info\s*$');
	    $section->exclude_body(qr'^Requires\(post,preun\): %__install_info\s*$');
	    $section->exclude_body(qr'^PreReq: \%__install_info\s*$');
	} else {
	    next unless $scriptsec{$secname};
# 	    $section->exclude(qr'^\s*\%install_info');
# 	    $section->exclude(qr'^\s*\%uninstall_info');
# 	    $section->exclude(qr'^\s*\%xemacs_install_info');
# 	    $section->exclude(qr'^\s*\%xemacs_uninstall_info');

# 	    $section->exclude(qr'install-info[^\\]*$');
# 	    $section->exclude(qr'^\s*\%__install_info[^\\]*$');

	    my @body=@{$section->get_bodyref()};
	    my @new_body;
	    my $multiline=0;
	    while (scalar @body) {
		$_=shift(@body);
		next if /^\s*\%install_info/;
		next if /^\s*\%uninstall_info/;
		next if /^\s*\%xemacs_install_info/;
		next if /^\s*\%xemacs_uninstall_info/;
		next if $multiline and /\\\s*$/;
		if ($multiline and not /\\\s*$/) {
		    $multiline=0;
		    next;
		}
		if (/^\s*\%__install_info/ or /install-info/) {
		    $multiline=1 if /\\\s*$/;
		    next;
		}
		push @new_body, $_;
	    }
	    $section->set_body(\@new_body);

	    my $flag_p=$section->get_flag('-p');
	    if ((!$flag_p && $section->is_empty()) or ($flag_p && $flag_p=~/install.info/)) {
		push @todel, [$secname,$section->get_raw_package(), $section->get_trigger_condition()];
	    }
	}
    }
    map {$spec->del_section($_->[0],$_->[1],$_->[2])} @todel;
};

1;

__END__


%post -p %install_info
%preun -p %uninstall_info
